MODULE operacoes_vetoriais

CONTAINS
		
REAL FUNCTION mod_vet(vetor)
	IMPLICIT NONE
	
	REAL, INTENT(IN), DIMENSION(:) :: vetor
	INTEGER :: N
	
	
!Parte desnecessria do cdigo, apenas para ilustrar como obter o tamanho	
	N = SIZE(vetor)	
	PRINT*, "Tamanho do vetor de entrada ", N
	
!Calcula o modulo do vetor
	
	mod_vet = SQRT(SUM(vetor*vetor))

END FUNCTION

END MODULE

PROGRAM test
	USE operacoes_vetoriais

	IMPLICIT NONE
	REAL, DIMENSION(:), ALLOCATABLE :: arr
	REAL :: mod
	
	INTEGER :: i, tamanho
	
	tamanho = 20
	
	ALLOCATE(arr(tamanho))
	
	
	arr = (/(i, i=1, tamanho)/)
	
	mod = mod_vet(arr)

	WRITE (6,*) "Vetor: "
	WRITE (6,'(100F16.6)') arr
	WRITE (6,'(A,F16.6)') "O modulo eh ", mod
	
	DEALLOCATE (arr)

END PROGRAM

